animeflix_app/urls.py
from django.urls import path
from django.views.generic import RedirectView

from .views import HomePageView, PremiumPageView, ChangeAccountToPremium, VideoPageView, AnimeDetailView, \
    VideoPageViewPremium, VideoPageViewAlphabetical, VideoPageViewSimulcast, MyAnimeListView, LoadMoreDataView, \
    VideoPageViewCategory, VideoPageViewPopular, VideoPageViewGenre, VideoPageViewSeason, \
    NewAnimeReview, UpdateAnimeReview, DeleteAnimeReview

urlpatterns = [
    path('', HomePageView.as_view(), name='home'),
    path('video', RedirectView.as_view(url='video/updated'), name='video'),
    path('video/updated', VideoPageView.as_view(), name='v_updated'),
    path('video/simulcast', VideoPageViewSimulcast.as_view(), name='v_simulcast'),
    path('video/popular', VideoPageViewPopular.as_view(), name='v_popular'),
    path('video/category', VideoPageViewCategory.as_view(), name='v_category'),
    path('video/genre', VideoPageViewGenre.as_view(), name='v_genre'),
    path('video/season', VideoPageViewSeason.as_view(), name='v_season'),
    path('video/alphabetical', VideoPageViewAlphabetical.as_view(), name='v_alphabetical'),
    path('video/premium', VideoPageViewPremium.as_view(), name='v_premium'),
    path('video/anime', AnimeDetailView.as_view(), name='v_anime_detail'),
    path('video/anime/reviews', AnimeDetailView.as_view(), name='v_anime_reviews'),
    path('video/anime/reviews/new-review', NewAnimeReview.as_view(), name='v_anime_new_review'),
    path('video/anime/reviews/edit-review<int:id_review>', UpdateAnimeReview.as_view(), name='v_anime_edit_review'),
    path('video/anime/reviews/delete-review<pk>', DeleteAnimeReview.as_view(), name='v_anime_delete_review'),
    path('myAnimeList', MyAnimeListView.as_view(), name='myAnimeList'),
    path('loadMoreAnimes', LoadMoreDataView.as_view(), name='load_more'),
    path('premium', PremiumPageView.as_view(), name='premium'),
    path('premium/subscribed', ChangeAccountToPremium.as_view(), name='subscribe')
]

animeflix_project/urls.py
import debug_toolbar
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path

from animeflix_project import settings

urlpatterns = [
    path('', include('animeflix_app.urls')),
    path('auth/', include('auth_app.urls')),
    path('forum/', include('forum.urls')),
    path('admin/', admin.site.urls),
    path('__debug__/', include(debug_toolbar.urls)),

] + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

forum/urls.py
from django.urls import path

from .views import ForumPageView, ThreadDetailView, NewThreadFormView, EditPostFormView, NewPostFormView, \
    EditThreadTitle, DeleteThreadView, DeletePostView

urlpatterns = [
    path('', ForumPageView.as_view(), name='forum'),
    path('new-thread', NewThreadFormView.as_view(), name='new_thread'),
    path('thread<pk>', ThreadDetailView.as_view(), name='thread_detail'),
    path('thread<pk>/edit-title', EditThreadTitle.as_view(), name='edit_title'),
    path('thread<pk>/delete', DeleteThreadView.as_view(), name='delete_thread'),
    path('thread<pk>/new-post', NewPostFormView.as_view(), name='new_post'),
    path('thread<pk>/new-post&reply-to=post<int:id_quote>', NewPostFormView.as_view(), name='reply_post'),
    path('thread<pk>/edit-post<int:id_post>', EditPostFormView.as_view(), name='edit_post'),
    path('thread<id_thread>/delete-post<pk>', DeletePostView.as_view(), name='delete_post')
]

animeflix_app/models.py
# This is an auto-generated Django model module.
# You'll have to do the following manually to clean this up:
#   * Rearrange models' order
#   * Make sure each model has one field with primary_key=True
#   * Make sure each ForeignKey and OneToOneField has `on_delete` set to the desired behavior
#   * Remove `managed = False` lines if you wish to allow Django to create, modify, and delete the table
# Feel free to rename the models, but don't rename db_table values or field names.

import datetime

from django.contrib.auth.models import User
from django.core.cache import cache
from django.db import models
from django.utils.timezone import is_aware, is_naive

from animeflix_project import settings


class Utente(models.Model):
    account = models.OneToOneField(User, on_delete=models.CASCADE, db_column='account', primary_key=True)
    eta = models.IntegerField(blank=True, null=True)
    nazionalita = models.CharField(max_length=50, blank=True, default='')
    abbonato = models.BooleanField(default=False)
    avatar = models.ImageField(upload_to='avatar', default='avatar/avatar-default.png')

    class Meta:
        db_table = 'ANIMEFLIX_utente'

    def __str__(self):
        if not self.account.is_active:
            return "user deleted"
        return self.account.get_username()

    def get_default_avatar_path(self):
        upload_folder = self.avatar.field.upload_to
        default_name = upload_folder + '-default.png'
        default_path = upload_folder + '/' + default_name
        return default_path

    def get_account_lists(self):
        return Lista.objects.filter(id_account=self).all()

    def last_seen(self):
        return cache.get('seen_%s' % self.account.username)

    def is_online(self):
        last_seen = self.last_seen()
        if last_seen:
            now = datetime.datetime.now()
            if now > last_seen + datetime.timedelta(seconds=settings.USER_ONLINE_TIMEOUT):
                return False
            else:
                return True
        else:
            return False

    def delete(self, using=None, keep_parents=False):
        if 'default' not in self.avatar.name:
            self.avatar.storage.delete(self.avatar.name)
        return super().delete(using, keep_parents)


class Categoria(models.Model):
    descrizione = models.CharField(primary_key=True, max_length=30)

    class Meta:
        db_table = 'ANIMEFLIX_categoria'


class Genere(models.Model):
    descrizione = models.CharField(primary_key=True, max_length=20)

    class Meta:
        db_table = 'ANIMEFLIX_genere'


class Anime(models.Model):
    categoria = models.ForeignKey(Categoria, on_delete=models.DO_NOTHING, db_column='categoria')
    titolo = models.CharField(max_length=50)
    trama = models.TextField()
    copertina = models.TextField()
    stato = models.BooleanField()
    premium = models.BooleanField()
    n_serie = models.IntegerField(blank=True, null=True, default=0)
    tot_episodi = models.IntegerField(blank=True, null=True, default=0)
    avg_rating = models.FloatField(default=0)

    class Meta:
        db_table = 'ANIMEFLIX_anime'
        ordering = ['titolo']

    def __str__(self):
        return f'{self.titolo}_{self.id}'

    def update_serie_counter(self):
        self.n_serie = self.serie_set.count()
        self.save(update_fields=['n_serie'])

    @property
    def short_trama(self):
        return self.trama if len(self.trama) < 35 else (self.trama[:33] + '..')

    def get_series(self):
        return Serie.objects.select_related('id_anime').filter(id_anime=self.id).order_by('id')

    def last_ep(self):
        return Episodio.objects.select_related('id_anime').filter(id_anime=self.id).order_by('-data_car',
                                                                                             '-ora_car').first()


class Animegenere(models.Model):
    id_anime = models.ForeignKey(Anime, on_delete=models.DO_NOTHING, db_column='id_anime')
    id_genere = models.ForeignKey(Genere, on_delete=models.DO_NOTHING, db_column='id_genere')

    class Meta:
        db_table = 'ANIMEFLIX_anime_genere'
        unique_together = [['id_anime', 'id_genere']]


class Stagionedellanno(models.Model):
    stagione = models.CharField(max_length=10)
    anno = models.IntegerField()

    class Meta:
        db_table = 'ANIMEFLIX_stagionedellanno'
        unique_together = [['stagione', 'anno']]

    def __str__(self):
        return f'{self.stagione} {self.anno}'


class Serie(models.Model):
    numero = models.FloatField()
    id_anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='id_anime')
    id_stag_anno = models.ForeignKey(Stagionedellanno, on_delete=models.DO_NOTHING, db_column='id_stag_anno')
    nome = models.CharField(max_length=50)
    n_episodi = models.IntegerField(blank=True, null=True)

    class Meta:
        db_table = 'ANIMEFLIX_serie'
        unique_together = [['id', 'id_anime']]

    def __str__(self):
        return f'{self.nome}_{self.id}'

    def update_n_episodi(self):
        self.n_episodi = self.episodio_set.count()
        self.save(update_fields=['n_episodi'])

    def get_episodes(self):
        return Episodio.objects.select_related('id_serie').filter(id_serie=self.id)

    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        self.id_anime.update_serie_counter()
        super().save()


class Episodio(models.Model):
    numero = models.FloatField()
    id_serie = models.ForeignKey(Serie, on_delete=models.CASCADE, db_column='id_serie')
    id_anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='id_anime')
    titolo = models.CharField(max_length=100)
    url_video = models.TextField()
    data_car = models.DateField(blank=True, null=True)
    ora_car = models.TimeField(blank=True, null=True)

    class Meta:
        db_table = 'ANIMEFLIX_episodio'
        unique_together = [['id', 'id_serie', 'id_anime']]

    def __str__(self):
        return f'{self.numero}_{self.titolo}_{self.id}'

    def daysPassed(self):
        delta = datetime.date.today() - self.data_car
        return delta.days

    def save(self, force_insert=False, force_update=False, using=None,
             update_fields=None):
        self.id_serie.update_n_episodi()
        super().save()


class Lista(models.Model):
    id = models.AutoField(primary_key=True)
    nome = models.CharField(max_length=12, null=False)
    id_account = models.ForeignKey(Utente, on_delete=models.CASCADE, to_field='account', db_column='id_account')

    class Meta:
        db_table = 'ANIMEFLIX_lista'
        unique_together = [['nome', 'id_account']]

    def get_animes(self):
        return ListaIncludeAnime.objects.filter(id_account=self.id_account, nome_lista=self).all()


class ListaIncludeAnime(models.Model):
    id_anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='id_anime')
    nome_lista = models.ForeignKey(Lista, on_delete=models.CASCADE, db_column='nome_lista', blank=True, null=True)
    id_account = models.ForeignKey(Utente, on_delete=models.CASCADE, db_column='id_account')

    class Meta:
        db_table = 'ANIMEFLIX_lista_include_anime'
        unique_together = [['id_anime', 'nome_lista', 'id_account']]


class Premium(models.Model):
    id = models.IntegerField(primary_key=True)
    durata = models.IntegerField(null=False)

    class Meta:
        db_table = 'ANIMEFLIX_premium'

    def __str__(self):
        return self.durata.__str__()


class AccountPremium(models.Model):
    id_account = models.ForeignKey(Utente, on_delete=models.CASCADE, db_column='id_account')
    id_premium = models.ForeignKey(Premium, on_delete=models.CASCADE, db_column='id_premium')
    data_inizio = models.DateField(auto_now_add=True)
    data_fine = models.DateField(editable=False)
    scaduto = models.BooleanField(default=False, editable=False)

    class Meta:
        db_table = 'ANIMEFLIX_account_premium'
        unique_together = [['id_account', 'id_premium']]

    def save(self, *args, **kwargs):
        offert = self.id_premium
        self.data_inizio = datetime.date.today()
        self.data_fine = self.data_inizio + datetime.timedelta(days=offert.durata)
        return super().save(*args, **kwargs)

    def delete(self, *args, **kwargs):
        self.id_account.abbonato = False
        self.id_account.save(update_fields=['abbonato'])
        return super().delete(*args, **kwargs)


class Evaluation(models.Model):
    author = models.ForeignKey(Utente, on_delete=models.CASCADE, db_column='author')
    anime = models.ForeignKey(Anime, on_delete=models.CASCADE, db_column='anime')
    title = models.CharField(blank=False, max_length=100)
    review = models.TextField(blank=False)
    vote = models.PositiveSmallIntegerField(null=False)
    creation_date = models.DateTimeField(auto_now_add=True, editable=False)
    mod_date = models.DateTimeField(auto_now=True)

    class Meta:
        db_table = 'ANIMEFLIX_evaluation'
        unique_together = [['author', 'anime']]
        ordering = ['creation_date']

    def creation_date_str(self):
        return self.creation_date.strftime("%d-%m-%Y")

    def mod_date_str(self):
        return self.mod_date.strftime("%d-%m-%Y")

animeflix_app/forms.py
from django import forms
from animeflix_app.models import Evaluation


class ReviewForm(forms.ModelForm):
    vote = forms.IntegerField(
        error_messages={
            'required': "Don't forget to assign a vote"
        },
        required=True,
        label="Vote*",
        widget=forms.NumberInput(attrs={"class": "d-none"})
    )

    title = forms.CharField(
        error_messages={
            'required': "Don't forget to assign a title"
        },
        required=True,
        label="Title*",
        widget=forms.TextInput(attrs={"class": "form-control form-input"})
    )

    review = forms.CharField(
        error_messages={
            'required': "Don't forget to write a review"
        },
        required=True,
        label="Review*",
        widget=forms.Textarea(attrs={"class": "form-control form-input", "autofocus": True})
    )

    class Meta:
        model = Evaluation
        fields = ['vote', 'title', 'review']


animeflix_app/templates/animeflix_app/animeEvaluation/animeRating.html
<div class="review-stat">
    {% for i in stars_list %}
        {% if not single_anime.avg_rating.is_integer and i|add:"-1" < single_anime.avg_rating and i > single_anime.avg_rating %}
            <i class="half-star rating-color"></i>
            <i class="star"></i>
        {% elif i <= single_anime.avg_rating %}
            <i class="half-star rating-color"></i>
            <i class="star rating-color"></i>
        {% else %}
            <i class="half-star"></i>
            <i class="star"></i>
        {% endif %}
    {% endfor %}
</div>

animeflix_app/templates/animeflix_app/animeEvaluation/deleteReviewModal.html
<form action="{% url 'v_anime_delete_review' eval.pk %}" method="post"> {% csrf_token %}
    <div id="del-review-{{ eval.pk }}-modal" class="modal fade del-post-modal" tabindex="-1">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content" >
                <div class="modal-header">
                    <h3 class="primary-text-color">Confirm delete</h3>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body text-center p-5">
                    <h5>Are you sure you want to delete this review?</h5>
                </div>
                <div class="modal-footer d-flex justify-content-between">
                    <button type="submit" class="btn btn-primary">
                        <input type="hidden" name="watch" value="{{ single_anime.pk }}">
                        YES
                    </button>
                    <button type="button" data-bs-dismiss="modal" class="btn btn-primary">NO</button>
                </div>
            </div>
        </div>
    </div>
</form>

animeflix_app/templates/animeflix_app/animeEvaluation/newReview.html
{% extends 'animeflix_app/pages/animeDetail.html' %}
{% load static %}

{% block new-review %}
    <h3 class="text-center primary-text-color">Vote and write your review</h3>
    <form class="p-3" method="post" novalidate>{% csrf_token %}
        {% for field in form %}
            <div class="form-row pb-2">
                <div class="form-group col-12">
                    {% if 'vote' in field.id_for_label %}
                        <div class="d-flex">
                            <label for="{{ field.id_for_label }}" class="form-label fw-bold pe-4">
                                {{ field.label }}
                            </label>
                            <fieldset id="stars-voting" class="rating">
                                <input type="radio" id="star5" name="rating" value="5" />
                                <label class="full" for="star5" title="awesome - 5 stars"></label>
                                <input type="radio" id="star4" name="rating" value="4" />
                                <label class="full" for="star4" title="Pretty good - 4 stars"></label>
                                <input type="radio" id="star3" name="rating" value="3" />
                                <label class="full" for="star3" title="Meh - 3 stars"></label>
                                <input type="radio" id="star2" name="rating" value="2" />
                                <label class="full" for="star2" title="Kinda bad - 2 stars"></label>
                                <input type="radio" id="star1" name="rating" value="1" />
                                <label class="full" for="star1" title="So ugly - 1 star"></label>
                            </fieldset>
                        </div>
                    {% else %}
                        <label for="{{ field.id_for_label }}" class="form-label fw-bold">{{ field.label }}</label>
                    {% endif %}

                    {{ field }}
                    {% if field.errors %}
                        <div class="invalid-feedback d-block text-center">
                            {{ field.errors }}
                        </div>
                    {% endif %}
                </div>
            </div>
        {% endfor %}

        <div class="d-flex">
            <button type="button" class="btn btn-primary text-editor-btn me-2">TEXT EDITOR</button>
            <input type="submit" class="btn btn-primary px-3 me-auto"
                   value="{% if 'edit' in request.path %}EDIT{% else %}CREATE{% endif %} REVIEW">
            <a href="{% url 'v_anime_reviews' %}?watch={{ anime.pk }}" class="btn btn-primary px-3">CANCEL</a>
        </div>
    </form>


<script>
    let vote_input = $('#id_vote');
    let star_input = $('fieldset#stars-voting input');

    // Update vote input in the form by number of stars selected
    star_input.click(function () {
        vote_input.val($(this).val());
    });

    if (vote_input.val() !== 0) {
        star_input.each(function() {
            let id = $(this).attr('id').slice(-1);
            if (id === vote_input.val())
                $(this).click();
        });
    }

</script>

{% endblock %}